{
COMFREQ3
Pomiar czestotliwosci metoda zliczania zdarzen w jednostce czasu (1s)
(C)Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}

uses dos,tmr,keyboard;

const
 IER=1;
 MCR=4;
 MSR=6;
 DSR=32;
 CTS=16;

var
 oldInt:pointer; {na przechowanie starego adresu obslugi IRQ 3/4}
 i:longint; {licznik zdarzen}
 s:string;
 maska:byte;
 adr:word;
 COMInt:byte;
 COMIntMask:byte;


{$F+}
procedure ComHandler;interrupt;
begin
 if port[adr+MSR] and maska=0 then inc(i);
 port[$20]:=$20;
end;
{$F-}

procedure Blad;
begin
 writeln;
 writeln('COMFREQ3 par1 par2');
 writeln('Pomiar czestotliwosci metoda zliczania zdarzen w jednostce czasu');
 writeln('par1 - numer portu');
 writeln('par2 - D dla DSR, C dla CTS');
 halt;
end;

begin
 if ParamCount <> 2 then blad;
 s:=ParamStr(1);
 case s[1] of
 '1':begin
      adr:=$3f8;
      ComInt:=$0C;
      ComIntMask:=$10;
     end;
 '2':begin
      adr:=$2f8;
      ComInt:=$0B;
      ComIntMask:=$08;
     end;
  else blad;
 end;

 s:=ParamStr(2);
 case UpCase(s[1]) of
 'D':maska:=DSR;
 'C':maska:=CTS;
 else blad;
 end;

 asm sti end; {Zablokuj wszystkie przerwan}
 GetIntVec(ComInt,oldInt); {Zapamietaj stary i ustaw nowa procedure obslugi przerwania}
 SetIntVec(ComInt,@ComHandler);
 port[$21]:=port[$21]and (not ComIntMask); {Wlacz obslue przerwania}
 port[adr+IER]:=8; {Zrodlo zdarzen - zmiana stanu linii modemowych}
 port[adr+MCR]:=12;{Wlacz obsluge zdarzen w UART}
 asm sti end; {Odblokuj przerwania}

 WriteLN(#10#13'Pomiar czestotliwosci przez zliczanie zdarzen.');
 writeln('Nacisnij dowolny klawisz aby zakonczyc');
 write('Mierzona czestotliwosc [Hz]=');

 ff:=100; {Czestotliwosc wyzwalania int8, ktore posluzy do dokladnego
           odmierzenia 1s }

 repeat
  StartInt(Int8);{rozpocznij pomiar czasu przez zliczanie int8h}
  asm cli end;
  Licznik8h:=0;
  i:=0;
  asm sti end;

  repeat until licznik8h>=ff;{Po uplywie 1s zakoncz pomiar}
  StopInt;

  write(i:6,#8#8#8#8#8#8); {Wyswietl ilosc zdarzen}
 until keypressed;

 writeln;

 asm cli end; {Przywrocenie dla rejestrow UART wartosci domyslnych}
 port[adr+IER]:=0;
 port[adr+MCR]:=0;
 port[$21]:=port[$21] or ComIntMask;
 SetIntVec(ComInt,oldInt);
 asm sti end;
end.