uses dos,crt,tmr;

const
 COMInt:byte=$0b;
 COMIntMask:byte=8;
 IER=1;
 MCR=4;
 MSR=6;
 adr:word=$2f8;
 DSR=32;
 CTS=16;
 maska:byte=DSR;

var
 oldInt:pointer;
 i:longint;
 timer:longint absolute $40:$6c;
 t1:longint;


{$F+}
procedure ComHandler;interrupt;
begin
 if port[adr+MSR] and maska=0 then inc(i);
 port[$20]:=$20;
end;


begin
 asm sti end; {Zablokuj wszystkie przerwan}
 GetIntVec(ComInt,oldInt); {Zapamietaj stary i ustaw nowa procedure obslugi przerwania}
 SetIntVec(ComInt,@ComHandler);
 port[$21]:=port[$21]and (not ComIntMask); {Wlacz obslue przerwania}
 port[adr+IER]:=8; {Zrodlo zdarzen - zmiana stanu linii modemowych}
 port[adr+MCR]:=12;{Wlacz obsluge zdarzen w UART}
 asm sti end; {Odblokuj przerwania}

 clrscr;
 WriteLN('Pomiar czestotliwosci przez zliczanie zdarzen.');
 writeLN('Mierzona czestotliwosc           [Hz]');
 writeln('Nacisnij dowolny klawisz aby zakonczyc');

 ff:=1000; {Czestotliwosc wyzwalania int8}
 repeat
  gotoxy(24,2);
  StartInt(Int8);
  asm cli end;
  Licznik8h:=0;
  i:=0;
  asm sti end;

  repeat until licznik8h>=1000;
  StopInt;
  write(i:6);
 until keypressed;

 asm cli end;
 port[adr+IER]:=0;
 port[adr+MCR]:=0;
 port[$21]:=port[$21] or ComIntMask;
 SetIntVec(ComInt,oldInt);
 asm sti end;
end.