{
COMGEN3 - generowanie sygnalu prostokatnego o wypelnieniu 50%
na linii TxD poprzez wysyanie do UARTa znaku "U", dajacego przebieg
prostokatny o czestotliwosci rownej polowie predkosci (bps / 2)

autor: Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}
uses keyboard;

const
 znak=0 + 64 + 0 + 16 + 0 + 4 + 0 + 1; {"U"}

var
 adr,f,i:word;
 s:string;

procedure blad;
begin
 writeln(#10#13'COMGEN3 par1 par2');
 writeln('generowanie sygnalu prostokatnego o wypelnieniu 50% na linii TxD');
 writeln('par1- numer portu');
 writeln('par2- czestotliwosc');
 writeln('Dopuszczalne czestotliwosci:');
 for i:=1 to 57600 do
  if 57600 mod i=0 then write(i,',');
 writeln(#8,' [Hz]');
 halt;
end;

begin
 if ParamCount<>2 then blad;
 s:=ParamStr(1);
 case s[1] of
 '1':adr:=$3f8;
 '2':adr:=$2f8;
 end;
 val(ParamStr(2),f,i);
 if i<>0 then blad;
 if 57600 mod f<>0 then blad;

 {Ustalenie parametrow transmisji}
 port[adr + 3]:=port[adr + 3] OR 128;
 port[adr + 1]:=hi(115200 div f div 2);
 port[adr]:=lo(115200 div f div 2);
 port[adr + 3]:=port[adr + 3] AND NOT 128;
 port[adr + 3]:=3 OR 0 OR 0;

 {Cykliczne wysylanie znaku}
 writeln(#10#13'Trwa generacja czestotliwosci ',f,'Hz');
 writeln('Nacisnij dowolny klawisz aby zakonczyc');
 repeat
  repeat until port[adr+5] and $20>0;
  port[adr]:=znak;
 until keypressed;
end.
