{autor Grzegorz P.
grzegorz.podgorski@wp.pl}

uses graph,tmr,keyboard;

const
 maskaDSR=32;
 maskaCTS=16;

var
  i,j,k:integer;
  x,yd,yd1,yc,yc1,adr:word;
  s:string;
  c:char;

label koniec;

function IntToStr(i:word):string;
var s:string;
begin
 str(i,s);
 IntToStr:=s;
end;


{$F+}
procedure int8h;interrupt;
var i:byte;
begin
 i:=port[adr+6];
 if i and maskaDSR=maskaDSR then yd:=50 else yd:=150;
 if i and maskaCTS=maskaCTS then yc:=200 else yc:=300;
 SetColor(0);line(x,50,x,150);line(x,200,x,300);SetColor(15);
 PutPixel(x,yc,15);
 PutPixel(x,yd,15);
 if yc<>yc1 then line(x,yc,x,yc1);
 if yd<>yd1 then line(x,yd,x,yd1);
 yc1:=yc;
 yd1:=yd;
 inc(x); if x>GetMaxX then x:=1;
 port[$20]:=$20;
end;
{$F-}

procedure WlaczGrafike;
var
  grDriver,grMode,errCode:Integer;
begin
 grDriver := detect;
 InitGraph(grDriver,grMode,'');
 errCode:=GraphResult;
 if errCode = grOk then exit;
 writeLn('Blad inicjacji grafiki:',GraphErrorMsg(ErrCode));
end;

procedure blad;
begin
 writeln(#10#13'Cyfrowy Oscyloskop 2-kanalowy (CTS i DSR)');
 writeln('Uzycie: COMOSC par1 [par2]');
 writeln('par1 - cyfra oznaczajaca numer portu np. 1');
 writeln('par2 - czestosc probkowania w Hz domyslnie 1000');
 writeln('Przyklad: COMOSC 1');
 halt;
end;


begin
 if (ParamCount<1)or(ParamCount>2) then blad;
 s:=ParamStr(1);
 case s[1] of
 '1':adr:=$3f8;
 '2':adr:=$2f8;
 else blad;
 end;

 ff:=1000;

 if ParamCount=2 then begin
  val(ParamStr(2),ff,i);
  if i<>0 then blad;
 end;

 WlaczGrafike;
 OutTextXY(100,1,'Cyfrowy Oscyloskop 2-kanalowy port com'+ParamStr(1)+' linie CTS i DSR');
 OutTextXY(250,GetMaxY-20,'autor: Grzegorz P. grzegorz.podgorski@wp.pl');
 OutTextXY(1,30,'Linia DSR');
 OutTextXY(1,180,'Linia CTS');
 OutTextXY(1,310,'Port com'+paramStr(1)+' Czestosc probkowania='+IntToStr(ff)+'Hz');
 OutTextXY(1,320,'czas H='+IntToStr(round(1/ff*GetMaxX*1000))+'ms');
 OutTextXY(1,330,'Nacisnij ESC aby zakonczyc, "SPACJE" aby zatrzymac');
 line(1,175,GetMaxX,175);
 for i:=1 to 10 do begin
  j:=i*GetMaxX div 10;
  line(j,173,j,177);
  OutTextXY(j-2,165,IntToStr(i));
 end;

 x:=1;
 yc1:=300;
 yd1:=150;

 startint(@int8h);
 repeat
  c:=ReadKey;
  if c=' ' then begin
   Zabron;
   OutTextXY(1,350,'Zatrzymany, "SPACJA"- wznowienie');
   while ReadKey<>' ' do;
   SetColor(0);
   for i:=350 to 370 do line(1,i,300,i);
   SetColor(15);
   zezwol;
  end;
 until c=#27;
 stopint;
koniec:
 CloseGraph;
end.



