{
LM35
Pomiar temperatury dla przetwornika TLC549 podlaczonego do PC przy pomocy
czujnika LM35

(C)Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}


uses crt;

const
 DTR=1;
 RTS=2;
 TxD=64;
 CTS=16;
 MSRadr=6;
 MCRadr=4;
 LCRadr=3;
 REF=2.48;{Napiecie odniesienia}
 ClockBit=TxD;
 ChipSelect=DTR;
 DataOut=CTS;
 Vcc=RTS;


var
 s:string;
 ch:char;
 l:word;
 kod:integer;
 MSR,MCR,LCR,adr:word;


procedure ADInit; {Zalaczenie zasilania i ustalenie adresow}
begin
 MCR:=adr+MCRadr;
 MSR:=adr+MSRadr;
 LCR:=adr+LCRadr;
 port[MCR]:=RTS;
end;

function AD:byte;
var w,i:byte;
begin
 port[MCR]:=Vcc+ChipSelect;  {ChipSelect}
 port[LCR]:=clockBit;        {Clock}
 delay(10);
 port[MCR]:=Vcc;
 w:=0;
 for i:=7 DownTo 0 do begin
  port[LCR]:=clockBit;
  delay(10);
  if (port[MSR] and CTS)>0 then inc(w,1 shl i);
  port[LCR]:=0;
  delay(10);
 end;
 AD:=w;
end;

begin
 writeln(#10#13#10#13'LM35 - Pomiar temp. przy pomocy LM35 podlaczonego do przetwornika TLC549');
 s:=ParamStr(1);
 case s[1] of
   '1':adr:=$3f8;
   '2':adr:=$2f8;
   else begin
          writeln('LM35 par1');
          writeln('par1 - numer portu');
          halt;
       end;
 end;

 ADInit;
 write('Temperatura ["C]=');
 repeat
  write(100*AD*REF/256:4:0,#8#8#8#8);
 until Keypressed;
end.
