{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R+,S-,T-,V-,X+}
{$M 16384,0,655360}

{
TLCSCO
Oscyloskopik dla przetwornika TLC549 podlaczonego do PC
(C)Grzegorz P.
grzegorz.podgorski@wp.pl
http://www.w.cz.prv.pl
}

uses keyboard,graph,tmr;

const
 k:byte=2; {wsp skali dla X}
 spow:word=1; {spowolnienie dla szybkich komp}
 PojemnoscBuf=650*2;
 narast=1;opad=2;brak=3;
 synchNazwa:array[1..3]of string[10] =('NARAST','OPAD','BRAK');
 synch:byte=narast;
 synchLevel:byte=5;

 DTR=1;  {Clock}
 RTS=2;  {Vcc}
 TxD=64; {ChipSelect}
 CTS=16; {DataOut}
 MSRadr=6;
 MCRadr=4;
 LCRadr=3;
 ClockBit=TxD;
 ChipSelect=DTR;
 DataOut=CTS;
 Vcc=RTS;


var
 tabl1:array[0..PojemnoscBuf-1]of record {Tabl pomocnicza}
  bit:array[1..8]of byte;
 end;
 tabl:array[0..PojemnoscBuf-1]of byte; {bufor}
 i:byte;
 PodstawaCzasu:real;
 x,x1,y,y1:word;
 s:string;
 ch:char;
 l:word;
 kod:integer;
 MSR,MCR,LCR,adr:word;

label koniec,odswiez;

procedure blad(s:string);
begin
 writeln(s);
 halt;
end;

function IntToStr(i:longint):string;
var s:string;
begin
 str(i,s);
 IntToStr:=s;
end;

function InicjujGraph:boolean;
var
 grDriver: Integer;
 grMode: Integer;
begin
 grDriver := Detect;
 InitGraph(grDriver, grMode,' ');
 if GraphResult<>grOK then blad('Blad inicjacji grafiki!');
end;

procedure ADInit;
begin
 MCR:=adr+MCRadr;
 MSR:=adr+MSRadr;
 LCR:=adr+LCRadr;
 port[MCR]:=RTS;
end;

procedure czekaj1;assembler;
asm
 push cx
 mov cx,spow
@p:
 loop @p
 pop cx
end;

procedure czekaj0;assembler;
asm
 push cx
 mov cx,spow
@p:
 loop @p
 pop cx
end;



function ADasm:byte;
begin
 asm
  mov cx,PojemnoscBuf
  push ds
  pop es
  mov di,OFFSET tabl1
@p:
  mov dx,LCR {ClockBit=1}
  mov al,ClockBit
  out dx,al

  mov al,Vcc+ChipSelect   {CS=1}
  mov dx,MCR
  out dx,al

  call czekaj1

  mov al,Vcc  {CS=0}
  out dx,al

  mov dx,MSR {Bit 8}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 7}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 6}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 5}
  in al,dx
  stosb

    mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 4}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 3}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 2}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  mov dx,MSR {Bit 1}
  in al,dx
  stosb

  mov dx,LCR {Clock=1}
  mov al,ClockBit;
  out dx,al

  call czekaj1

  mov al,0   {Clock=0}
  out dx,al

  call czekaj0

  dec cx
  jnz @p
 end;
end;

procedure ConvertADAsmToTabl;
var i:word;
begin
 FillChar(tabl,sizeof(Tabl),0);
 for i:=0 to PojemnoscBuf-1 do
  with tabl1[i] do begin
   if bit[1] and CTS>0 then inc(tabl[i],128);
   if bit[2] and CTS>0 then inc(tabl[i],64);
   if bit[3] and CTS>0 then inc(tabl[i],32);
   if bit[4] and CTS>0 then inc(tabl[i],16);
   if bit[5] and CTS>0 then inc(tabl[i],8);
   if bit[6] and CTS>0 then inc(tabl[i],4);
   if bit[7] and CTS>0 then inc(tabl[i],2);
   if bit[8] and CTS>0 then inc(tabl[i],1);
  end;
end;

{Inny algorytm odczytu AD - tu nieuzywany bo zbyt wolny}

function AD1:byte;
var w,i:byte;
begin
 port[MCR]:=RTS+DTR;  {ClockBit}
 port[LCR]:=TxD;      {ChipSelectBit}
 czekaj1;
 port[LCR]:=0;
 w:=0;
 for i:=7 DownTo 0 do begin
  port[MCR]:=RTS+DTR;
  czekaj1;
  if (port[MSR] and CTS)>0 then inc(w,1 shl i);
  port[MCR]:=RTS;
  czekaj0;
 end;
 AD1:=w;
end;

{Jeszcze inny algorytm odczytu AD - tu nieuzywany bo zbyt wolny}
function AD:byte;
var w:byte;
begin
 w:=0;
 port[MCR]:=RTS+DTR; {ClockBit}
 port[LCR]:=TxD;{ChipSelectBit}
 czekaj1;
 port[LCR]:=0;
 if (port[MSR] and CTS)>0 then inc(w,128);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
 if (port[MSR] and CTS)>0 then inc(w,64);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,32);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,16);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,8);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,4);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,2);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
if (port[MSR] and CTS)>0 then inc(w,1);
 port[MCR]:=RTS+DTR;
 czekaj1;
 port[MCR]:=RTS;
 czekaj0;
 AD:=w;
end;


begin
 writeln(#10#13'TLCSCO - Oscyloskopik dla TLC549 podlaczonego do RS232C w PC');
 if ParamCount=0 then blad('TLCSCO par1 [par2]'#10#13+
 'par1 - numer portu: 1 lub 2'#10#13+
 'par2 - wsp. spowolnienia 1-65535 dla wolnych kompow 1, dla szybszych wiecej, ale max 65535');

 s:=ParamStr(1);
 case s[1] of
   '1':adr:=$3f8;
   '2':adr:=$2f8;
   else blad('Niepoprawny numer portu, moze byc tylko 1 lub 2');
 end;

 if ParamCount =2 then val(ParamStr(2),spow,kod);
 if (ParamCount=2)and((kod<>0)or(spow=0)) then blad('Niepoprawnie podany wspolczynik spowolnienia');


 ADInit;
 InicjujGraph;
 SetFillStyle(0,0);

Odswiez:
  clearDevice;
  start2;
  ADAsm;
  stop2;

  OutTextXY(300,1,'TLC549 Oscyloskop - (C)Grzegorz P.');
  OutTextXY(1,1,'Czestotliwosc probkowania='+IntToStr(round(0.001/(pomiar/PojemnoscBuf)))+' kHz');

  PodstawaCzasu:=(pomiar / PojemnoscBuf) * 640 * 1000 / k;
  OutTextXY(1,20,'Podstawa czasu='+IntToStr(round(PodstawaCzasu))+' ms');
  OutTextXY(1,40,'Powiekszenie = '+IntToStr(k));
  OutTextXY(1,50,'Wyzwalanie:'+synchNazwa[synch]);
  OutTextXY(1,60,'Poziom wyzwalania:'+IntToStr(synchLevel));
  OutTextXY(300,20,'+ lub - powiekszanie');
  OutTextXY(300,30,'SPACJA-pauza');
  OutTextXY(300,40,'ENTER-wyzwalanie');
  OutTextXy(300,50,'P-poziom wyzwalania');
  OutTextXY(300,60,'ESC-koniec');


 repeat
  OutTextXY(1,400-128,'Rejestruje...');
  ADAsm;
  ConvertADAsmToTabl;
  move(tabl[9],tabl[0],640);
  case synch of
   narast:begin
    for x:=0 to 639 do if (tabl[x]<=SynchLevel)and(tabl[x+1]>SynchLevel) then break;
    if x<639 then move(tabl[x],tabl[0],640);
   end;
   opad:begin
    for x:=0 to 639 do if (tabl[x]>=SynchLevel)and(tabl[x+1]<SynchLevel) then break;
    if x<639 then move(tabl[x],tabl[0],640);
   end;
  end;

  for x:=0 to 639 do begin
   if keypressed then Break;
   bar(x*k,400-256,x*k+k,400);
   setColor(red);line(x*k+k,400-256,x*k+k,400);
   setColor(green); {podz pozioma}
   for i:=0 to 8 do line(x*k,400-i*32,x*k+k,400-i*32);

   if (x*k) mod 40=0 then begin {podz pionowa}
    SetColor(green);
    line(x*k,400,x*k,400-256);
    str(podstawaCzasu*x/640*k:2:k div 8,s);
    outTextXY(x*k,405,s);
   end;
   y:=400-tabl[x];
   SetColor(white);
   if x=0 then begin
    y1:=y;
    x1:=x;
   end;
   line(x1*k,y1,x*k,y);
   y1:=y;
   x1:=x;
  end;

  if keypressed then
   case ReadKey of
   '+':if k<32 then begin k:=k*2; goto Odswiez;end;
   '-':if k>1 then begin k:=k div 2;goto Odswiez; end;
   #27:goto koniec;
   ' ':begin OutTextXY(1,400-128,'Pauza. Nacisnij cos.'); ReadKey;end;
   #13:begin
        inc(synch);
        if synch>3 then synch:=1;
        goto Odswiez;
       end;
   'p':begin
        outTextXY(1,100,'Wprowadz poziom wyzwalania(0-255)=');
        s:='';
        repeat
         ch:=ReadKey;
         if (ch in ['0'..'9']) and (length(s)<4) then
          begin
           s:=s+ch;
           outTextXY(300,100,'          ');
           outTextXY(300,100,s);
          end;
        until ch=#13;
        val(s,synchLevel,kod);
        goto odswiez;
       end;
   end;
 until false;
koniec:
 closeGraph;
 port[MCR]:=0;
end.
